<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Signal I/O Interface: signal_io.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Signal I/O Interface
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a>  </div>
  <div class="headertitle">
<div class="title">signal_io.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Signal aquisition/generation functions.  
<a href="#details">More...</a></p>
<div class="textblock"><code>#include &lt;math.h&gt;</code><br />
<code>#include &quot;plugin_loader/loader_macros.h&quot;</code><br />
</div>
<p><a href="signal__io_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:ae71449b1cc6e6250b91f539153a7a0d3"><td class="memItemLeft" align="right" valign="top"><a id="ae71449b1cc6e6250b91f539153a7a0d3"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="signal__io_8h.html#ae71449b1cc6e6250b91f539153a7a0d3">M_PI</a>&#160;&#160;&#160;3.14159</td></tr>
<tr class="memdesc:ae71449b1cc6e6250b91f539153a7a0d3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Defines mathematical Pi value if standard math.h one is not available. <br /></td></tr>
<tr class="separator:ae71449b1cc6e6250b91f539153a7a0d3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abbfd9cc7317f32e493214abe56727574"><td class="memItemLeft" align="right" valign="top"><a id="abbfd9cc7317f32e493214abe56727574"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="signal__io_8h.html#abbfd9cc7317f32e493214abe56727574">SIGNAL_IO_DEVICE_INVALID_ID</a>&#160;&#160;&#160;-1</td></tr>
<tr class="memdesc:abbfd9cc7317f32e493214abe56727574"><td class="mdescLeft">&#160;</td><td class="mdescRight">Device identifier to be returned on device creation errors. <br /></td></tr>
<tr class="separator:abbfd9cc7317f32e493214abe56727574"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a55f9eceb88279ac2519c9051f13c816f"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="signal__io_8h.html#a55f9eceb88279ac2519c9051f13c816f">SIGNAL_IO_INTERFACE</a>(Namespace,  INIT_FUNCTION)</td></tr>
<tr class="memdesc:a55f9eceb88279ac2519c9051f13c816f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Signal input/output interface declaration macro.  <a href="#a55f9eceb88279ac2519c9051f13c816f">More...</a><br /></td></tr>
<tr class="separator:a55f9eceb88279ac2519c9051f13c816f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Signal aquisition/generation functions. </p>
<p>Physical/virtual signal aquisition and generation interface to be implemented by hardware specific plugins </p>
</div><h2 class="groupheader">Macro Definition Documentation</h2>
<a id="a55f9eceb88279ac2519c9051f13c816f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a55f9eceb88279ac2519c9051f13c816f">&#9670;&nbsp;</a></span>SIGNAL_IO_INTERFACE</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="classSIGNAL__IO__INTERFACE.html">SIGNAL_IO_INTERFACE</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">Namespace, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">INIT_FUNCTION&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line">INIT_FUNCTION( <span class="keywordtype">int</span>, Namespace, <a class="code" href="classSIGNAL__IO__INTERFACE.html#a039ba55e464174ac0beeed7f526cd3b4">InitDevice</a>, <span class="keyword">const</span> <span class="keywordtype">char</span>* ) \</div><div class="line">        INIT_FUNCTION( <span class="keywordtype">void</span>, Namespace, <a class="code" href="classSIGNAL__IO__INTERFACE.html#ac32d0abaa20630f96d1f31f3a1bbb514">EndDevice</a>, <span class="keywordtype">int</span> ) \</div><div class="line">        INIT_FUNCTION( <span class="keywordtype">void</span>, Namespace, <a class="code" href="classSIGNAL__IO__INTERFACE.html#a5599e5cda769dd5e93674cb43861c6eb">Reset</a>, <span class="keywordtype">int</span> ) \</div><div class="line">        INIT_FUNCTION( <span class="keywordtype">bool</span>, Namespace, <a class="code" href="classSIGNAL__IO__INTERFACE.html#a8d019a016130cb7319ea50bb5458beaf">HasError</a>, <span class="keywordtype">int</span> ) \</div><div class="line">        INIT_FUNCTION( <span class="keywordtype">size_t</span>, Namespace, <a class="code" href="classSIGNAL__IO__INTERFACE.html#a90e8d1884a11392fba57fae28158069a">GetMaxInputSamplesNumber</a>, <span class="keywordtype">int</span> ) \</div><div class="line">        INIT_FUNCTION( <span class="keywordtype">size_t</span>, Namespace, <a class="code" href="classSIGNAL__IO__INTERFACE.html#a3ad20cf842431b4e1c310d9d28b7b47b">Read</a>, <span class="keywordtype">int</span>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <span class="keywordtype">double</span>* ) \</div><div class="line">        INIT_FUNCTION( <span class="keywordtype">bool</span>, Namespace, <a class="code" href="classSIGNAL__IO__INTERFACE.html#a2eb6f484ae27314d229d00fcbde2765d">CheckInputChannel</a>, <span class="keywordtype">int</span>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ) \</div><div class="line">        INIT_FUNCTION( <span class="keywordtype">bool</span>, Namespace, <a class="code" href="classSIGNAL__IO__INTERFACE.html#a348d27978c2c9363d154aaf3de2770c5">Write</a>, <span class="keywordtype">int</span>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <span class="keywordtype">double</span> ) \</div><div class="line">        INIT_FUNCTION( <span class="keywordtype">bool</span>, Namespace, <a class="code" href="classSIGNAL__IO__INTERFACE.html#ad5837cb13e9184cfea75ba579c7f53a5">AcquireOutputChannel</a>, <span class="keywordtype">int</span>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ) \</div><div class="line">        INIT_FUNCTION( <span class="keywordtype">void</span>, Namespace, <a class="code" href="classSIGNAL__IO__INTERFACE.html#a4898bde5d5cc66f84987f28bb127c420">ReleaseOutputChannel</a>, <span class="keywordtype">int</span>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> )</div><div class="ttc" id="classSIGNAL__IO__INTERFACE_html_a2eb6f484ae27314d229d00fcbde2765d"><div class="ttname"><a href="classSIGNAL__IO__INTERFACE.html#a2eb6f484ae27314d229d00fcbde2765d">SIGNAL_IO_INTERFACE::CheckInputChannel</a></div><div class="ttdeci">bool CheckInputChannel(int deviceID, unsigned int channel)</div><div class="ttdoc">Check reading availability for specified input channel of given device. </div></div>
<div class="ttc" id="classSIGNAL__IO__INTERFACE_html_a90e8d1884a11392fba57fae28158069a"><div class="ttname"><a href="classSIGNAL__IO__INTERFACE.html#a90e8d1884a11392fba57fae28158069a">SIGNAL_IO_INTERFACE::GetMaxInputSamplesNumber</a></div><div class="ttdeci">size_t GetMaxInputSamplesNumber(int deviceID)</div><div class="ttdoc">Gets number of samples aquired for every given device input channel on each Read() call...</div></div>
<div class="ttc" id="classSIGNAL__IO__INTERFACE_html_ac32d0abaa20630f96d1f31f3a1bbb514"><div class="ttname"><a href="classSIGNAL__IO__INTERFACE.html#ac32d0abaa20630f96d1f31f3a1bbb514">SIGNAL_IO_INTERFACE::EndDevice</a></div><div class="ttdeci">void EndDevice(int deviceID)</div><div class="ttdoc">Discards given signal input/output device data structure   </div></div>
<div class="ttc" id="classSIGNAL__IO__INTERFACE_html_a039ba55e464174ac0beeed7f526cd3b4"><div class="ttname"><a href="classSIGNAL__IO__INTERFACE.html#a039ba55e464174ac0beeed7f526cd3b4">SIGNAL_IO_INTERFACE::InitDevice</a></div><div class="ttdeci">int InitDevice(const char *deviceConfig)</div><div class="ttdoc">Creates plugin specific signal input/output device data structure. </div></div>
<div class="ttc" id="classSIGNAL__IO__INTERFACE_html_a8d019a016130cb7319ea50bb5458beaf"><div class="ttname"><a href="classSIGNAL__IO__INTERFACE.html#a8d019a016130cb7319ea50bb5458beaf">SIGNAL_IO_INTERFACE::HasError</a></div><div class="ttdeci">bool HasError(int deviceID)</div><div class="ttdoc">Verifies occurence of errors on given device. </div></div>
<div class="ttc" id="classSIGNAL__IO__INTERFACE_html_a4898bde5d5cc66f84987f28bb127c420"><div class="ttname"><a href="classSIGNAL__IO__INTERFACE.html#a4898bde5d5cc66f84987f28bb127c420">SIGNAL_IO_INTERFACE::ReleaseOutputChannel</a></div><div class="ttdeci">void ReleaseOutputChannel(int deviceID, unsigned int channel)</div><div class="ttdoc">Give up exclusive access for specified output channel of given device. </div></div>
<div class="ttc" id="classSIGNAL__IO__INTERFACE_html_a3ad20cf842431b4e1c310d9d28b7b47b"><div class="ttname"><a href="classSIGNAL__IO__INTERFACE.html#a3ad20cf842431b4e1c310d9d28b7b47b">SIGNAL_IO_INTERFACE::Read</a></div><div class="ttdeci">size_t Read(int deviceID, unsigned int channel, double *ref_value)</div><div class="ttdoc">Reads samples list from specified channel of given device. </div></div>
<div class="ttc" id="classSIGNAL__IO__INTERFACE_html_a5599e5cda769dd5e93674cb43861c6eb"><div class="ttname"><a href="classSIGNAL__IO__INTERFACE.html#a5599e5cda769dd5e93674cb43861c6eb">SIGNAL_IO_INTERFACE::Reset</a></div><div class="ttdeci">void Reset(int deviceID)</div><div class="ttdoc">Resets data and errors for given device. </div></div>
<div class="ttc" id="classSIGNAL__IO__INTERFACE_html_a348d27978c2c9363d154aaf3de2770c5"><div class="ttname"><a href="classSIGNAL__IO__INTERFACE.html#a348d27978c2c9363d154aaf3de2770c5">SIGNAL_IO_INTERFACE::Write</a></div><div class="ttdeci">bool Write(int deviceID, unsigned int channel, double value)</div><div class="ttdoc">Writes value to specified channel of given device. </div></div>
<div class="ttc" id="classSIGNAL__IO__INTERFACE_html_ad5837cb13e9184cfea75ba579c7f53a5"><div class="ttname"><a href="classSIGNAL__IO__INTERFACE.html#ad5837cb13e9184cfea75ba579c7f53a5">SIGNAL_IO_INTERFACE::AcquireOutputChannel</a></div><div class="ttdeci">bool AcquireOutputChannel(int deviceID, unsigned int channel)</div><div class="ttdoc">Check availability and get exclusive access for specified output channel of given device...</div></div>
</div><!-- fragment -->
<p>Signal input/output interface declaration macro. </p>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.14
</small></address>
</body>
</html>
